/* AttendanceAdmins v2.0Beta */

#include <amxmodx>
#include <amxmisc>

new attendanceini[81],statisticsini[81],string[121],line,num
new regname[32],regip[32],adminname[32],adminip[32],str_regtime[7]
new current_ddmm[7],current_mmyy[7]
new current_aline,current_sline

public plugin_init() {
	register_plugin("AttendanceAdmins","2.0","ZETA [M|E|N]")
	register_clcmd("attendance","func_console_attendance",ADMIN_ALL,"")
	register_clcmd("attend","func_console_attendance",ADMIN_ALL,"")
	register_clcmd("statistics","func_statistics",ADMIN_ALL,"")
	register_clcmd("astats","func_statistics",ADMIN_ALL,"")
}

public plugin_cfg() {
	new configsdir[81]
	get_configsdir(configsdir,81)
	
	format(attendanceini,80,"%s/AttendanceAdmins/Attendance.ini",configsdir)
	format(statisticsini,80,"%s/AttendanceAdmins/Statistics.ini",configsdir)
	
	get_time("-%d.%m",current_ddmm,6)
	get_time("-%m.%y",current_mmyy,6)
	
	for(line=0;read_file(attendanceini,line,string,charsmax(string),num);line++) {
		if(string[0]=='-') {
			if(equal(string,current_ddmm)) current_aline=line+1
		}
	}
	if(!current_aline) {
		current_aline=line+2
		write_file(attendanceini,current_ddmm,line+1)
	}
	
	for(line=0;read_file(statisticsini,line,string,charsmax(string),num);line++) {
		if(string[0]=='-') {
			if(equal(string,current_mmyy)) current_sline=line+1
		}
	}
	if(!current_sline) {
		current_sline=line+2
		write_file(statisticsini,current_mmyy,line+1)
	}
}

public client_disconnect(id) {
	if(is_user_admin(id)) update_data(id)
}

update_data(id) {
	new updatefile[121],updatetime,gametime
	new regtime,bool:awrite,bool:swrite
	
	get_user_name(id,adminname,sizeof(adminname))
	get_user_ip(id,adminip,sizeof(adminip),1)
	gametime=get_user_time(id,1)/60
	
	for(line=current_aline;read_file(attendanceini,line,string,charsmax(string),num);line++) {
		if(num>0&&string[0]!=';') {
			parse(string,regname,charsmax(regname),regip,charsmax(regip),str_regtime,6)
			if(equali(adminname,regname)||equali(adminip,regip)) {
				regtime=str_to_num(str_regtime);updatetime=regtime+gametime
					
				format(updatefile,charsmax(updatefile),"^"%s^" ^"%s^" ^"%d^"",adminname,adminip,updatetime)
				write_file(attendanceini,updatefile,line);awrite=true
			}
		}
	}
	if(!awrite) {
		format(updatefile,charsmax(updatefile),"^"%s^" ^"%s^" ^"%d^"",adminname,adminip,gametime)
		write_file(attendanceini,updatefile,-1)
	}
	for(line=current_sline;read_file(statisticsini,line,string,charsmax(string),num);line++) {
		if(num>0&&string[0]!=';') {
			parse(string,regname,sizeof(regname),regip,sizeof(regip),str_regtime,6)
			if(equali(adminname,regname)||equali(adminip,regip)) {
				regtime=str_to_num(str_regtime);updatetime=regtime+gametime
					
				format(updatefile,charsmax(updatefile),"^"%s^" ^"%s^" ^"%d^"",adminname,adminip,updatetime)
				write_file(statisticsini,updatefile,line);swrite=true
			}
		}
	}
	if(!swrite) {
		format(updatefile,charsmax(updatefile),"^"%s^" ^"%s^" ^"%d^"",adminname,adminip,gametime)
		write_file(statisticsini,updatefile,-1)
	}
	return PLUGIN_HANDLED
}

public func_attendance(id) {
	new ddmm[7],param[6],amountch,aline
	read_argv(1,param,charsmax(param))
	
	amountch=strlen(param)
	
	switch(amountch) {
		case 0:{
			client_print(id,print_console,"===%s-==================",current_ddmm)
			write_data(id,attendanceini,current_aline,0)
			client_print(id,print_console,"===%s-==================",current_ddmm)
			return PLUGIN_HANDLED
		}
		case 2:{
			get_time("%m",ddmm,charsmax(ddmm))
			format(ddmm,6,"-%s.%s",param,ddmm)
			
			for(line=0;read_file(attendanceini,line,string,charsmax(string),num);line++) {
				if(string[0]=='-') {
					if(equal(string,ddmm)) aline=line+1
				}
			}
			if(!aline) {
				client_print(id,print_console,"===%s-==================",ddmm)
				write_data(id,attendanceini,aline,0)
				client_print(id,print_console,"===%s-==================",ddmm)
			}
			return PLUGIN_HANDLED
		}
		case 5:{
			if(contain(param,".")!=-1) {
				format(ddmm,6,"-%s",param)
				
				for(line=0;read_file(attendanceini,line,string,charsmax(string),num);line++) {
					if(string[0]=='-') {
						if(equal(string,ddmm)) aline=line+1
					}
				}
				if(!aline) {
					client_print(id,print_console,"===%s-==================",ddmm)
					write_data(id,attendanceini,aline,0)
					client_print(id,print_console,"===%s-==================",ddmm)
				}
				return PLUGIN_HANDLED
			}
			else if(contain(param,"/")!=-1) {
				replace(param,charsmax(param),"/","")
				
				new firstddmm[7],lastddmm[7],firstline,lastline
				parse(param,firstddmm,charsmax(firstddmm),lastddmm,charsmax(lastddmm))
				
				get_time("%m",ddmm,charsmax(ddmm))
				format(firstddmm,charsmax(firstddmm),"-%s.%s",firstddmm,ddmm)
				format(lastddmm,charsmax(lastddmm),"-%s.%s",lastddmm,ddmm)
				
				for(line=0;read_file(attendanceini,line,string,charsmax(string),num);line++) {
					if(string[0]=='-') {
						if(equal(string,firstddmm)) firstline=line+1
					}
				}
				
				for(line=0;read_file(attendanceini,line,string,charsmax(string),num);line++) {
					if(string[0]=='-') {
						if(equal(string,lastddmm)) lastline=line-1
					}
				}
				
				if((!firstline)&&(!lastline)&&(firstline!=lastline)) {
					client_print(id,print_console,"===%s-==================",firstddmm)
					if(firstline<lastline) write_data(id,attendanceini,firstline,lastline)
					else write_data(id,attendanceini,lastline,firstline)
					client_print(id,print_console,"===%s-==================",lastddmm)
				}
			}
			return PLUGIN_HANDLED
		}
		case 11:{
			if(contain(param,"/")!=-1) {
				replace(param,charsmax(param),"/","")
				
				new firstddmm[7],lastddmm[7],firstline,lastline
				parse(param,firstddmm,charsmax(firstddmm),lastddmm,charsmax(lastddmm))
				
				format(firstddmm,charsmax(firstddmm),"-%s",firstddmm)
				format(lastddmm,charsmax(lastddmm),"-%s",lastddmm)
				
				for(line=0;read_file(attendanceini,line,string,charsmax(string),num);line++) {
					if(string[0]=='-') {
						if(equal(string,firstddmm)) firstline=line+1
					}
				}
				
				for(line=0;read_file(attendanceini,line,string,charsmax(string),num);line++) {
					if(string[0]=='-') {
						if(equal(string,lastddmm)) lastline=line-1
					}
				}
				
				if((!firstline)&&(!lastline)&&(firstline!=lastline)) {
					client_print(id,print_console,"===%s-==================",firstddmm)
					if(firstline<lastline) write_data(id,attendanceini,firstline,lastline)
					else write_data(id,attendanceini,lastline,firstline)
					client_print(id,print_console,"===%s-==================",lastddmm)
				}
			}
			return PLUGIN_HANDLED
		}
		default:return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

public func_statistics(id) {
	new mmyy[7],param[6],amountch,sline
	read_argv(1,param,charsmax(param))
	
	amountch=strlen(param)
	
	switch(amountch) {
		case 0:{
			client_print(id,print_console,"===%s-==================",current_mmyy)
			write_data(id,statisticsini,current_sline,0)
			client_print(id,print_console,"===%s-==================",current_mmyy)
			return PLUGIN_HANDLED
		}
		case 2:{
			get_time("%y",mmyy,charsmax(mmyy))
			format(mmyy,6,"-%s.%s",param,mmyy)
			
			for(line=0;read_file(statisticsini,line,string,charsmax(string),num);line++) {
				if(string[0]=='-') {
					if(equal(string,mmyy)) sline=line+1
				}
			}
			if(!sline) {
				client_print(id,print_console,"===%s-==================",mmyy)
				write_data(id,statisticsini,sline,0)
				client_print(id,print_console,"===%s-==================",mmyy)
			}
			return PLUGIN_HANDLED
		}
		case 5:{
			if(contain(param,"/")!=-1) {
				replace(param,charsmax(param),"/","")
				
				new firstmmyy[7],lastmmyy[7],firstline,lastline
				parse(param,firstmmyy,charsmax(firstmmyy),lastmmyy,charsmax(lastmmyy))
				
				get_time("%m",mmyy,charsmax(mmyy))
				format(firstmmyy,charsmax(firstmmyy),"-%s.%s",firstmmyy,mmyy)
				format(lastmmyy,charsmax(lastmmyy),"-%s.%s",lastmmyy,mmyy)
				
				for(line=0;read_file(statisticsini,line,string,charsmax(string),num);line++) {
					if(string[0]=='-') {
						if(equal(string,firstmmyy)) firstline=line+1
					}
				}
				
				for(line=0;read_file(statisticsini,line,string,charsmax(string),num);line++) {
					if(string[0]=='-') {
						if(equal(string,lastmmyy)) lastline=line-1
					}
				}
				
				if((!firstline)&&(!lastline)&&(firstline!=lastline)) {
					client_print(id,print_console,"===%s-==================",firstmmyy)
					if(firstline<lastline) write_data(id,statisticsini,firstline,lastline)
					else write_data(id,statisticsini,lastline,firstline)
					client_print(id,print_console,"===%s-==================",lastmmyy)
				}
			}
			return PLUGIN_HANDLED
		}
		default:return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

write_data(id,file[],firstline,lastline) {
	switch(id) {
		case 0:{
			if(lastline) {
				for(line=firstline;read_file(file,line,string,charsmax(string),num);line++) {
					if(line<=lastline) {
						if(string[0]!='-') {
							parse(string,regname,charsmax(regname),regip,charsmax(regip),str_regtime,6)
									
							client_print(id,print_console,"%s  |  %s  |  %s",regname,regip,str_regtime)
						}
						else client_print(id,print_console,"%s",string)	
					}
					else return PLUGIN_HANDLED
				}
			}
			else {
				for(line=firstline;read_file(file,line,string,charsmax(string),num);line++) {
					if(num>0&&string[0]!='-') {
						parse(string,regname,charsmax(regname),regip,charsmax(regip),str_regtime,6)
									
						client_print(id,print_console,"%s  |  %s  |  %s",regname,regip,str_regtime)
					}
					else return PLUGIN_HANDLED
				}
			}
		}
		default:{
			if(lastline) {
				for(line=firstline;read_file(file,line,string,charsmax(string),num);line++) {
					if(line<=lastline) {
						if(string[0]!='-') {
							parse(string,regname,charsmax(regname),regip,charsmax(regip),str_regtime,6)
							
							server_print("%s  |  %s  |  %s",regname,regip,str_regtime)
						}
						else server_print("%s",string)	
					}
					else return PLUGIN_HANDLED
				}
			}
			else {
				for(line=firstline;read_file(file,line,string,charsmax(string),num);line++) {
					if(num>0&&string[0]!='-') {
						parse(string,regname,charsmax(regname),regip,charsmax(regip),str_regtime,6)
									
						server_print("%s  |  %s  |  %s",regname,regip,str_regtime)
					}
					else return PLUGIN_HANDLED
				}
			}
			
		}
	}
	return PLUGIN_HANDLED
}
